//+------------------------------------------------------------------+
//|                               MTF MCP Fractal_Bar_Indicator.mq4  |
//|                               Copyright © 2015, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//|                         Donate / Support:  http://goo.gl/cEP5h5  | 
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |                    
//|                                          mario.jemic@gmail.com   |
//|------------------------------------------------------------------|
//|                                     Paypal: http://goo.gl/cEP5h5 |
//|                     BitCoin: 1MfUHS3h86MBTeonJzWdszdzF2iuKESCKU  |
//+------------------------------------------------------------------+

#property copyright "Copyright © 2015, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"
#property indicator_separate_window

extern int Lookback=50;
extern int scaleX=30,// horizontal interval at which the squares are created
scaleY=30,           // vertical interval
offsetX=60,          // horizontal indent of all squares
offsetY=30,          // vertical indent
fontSize=30;         // font size

extern string Instrument1= "EURUSD";
extern string Instrument2= "USDJPY";
extern string Instrument3= "GBPUSD";
extern string Instrument4= "USDCHF";
extern string Instrument5= "AUSUSD";
extern string Instrument6= "USDCAD";
extern string Instrument7= "NZDUSD";
extern string Instrument8= "EURJPY";
extern string Instrument9= "EURGBP";
extern string Instrument10= "GBPJPY";
string PAIR[]={"1","2","3", "4", "5", "6", "7", "8", "9", "10"}; 
string TF[]={"m1", "m5", "m15","m30", "H1", "H4", "D1", "W1", "MN1"};
string iTF[]={1, 5, 15,30, 60, 240 , 1440, 10080, 43200};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
	PAIR[0]= Instrument1;
	PAIR[1]= Instrument2;
	PAIR[2]= Instrument3;
	PAIR[3]= Instrument4;
	PAIR[4]= Instrument5;
	PAIR[5]= Instrument6;
	PAIR[6]= Instrument7;
	PAIR[7]= Instrument8;
	PAIR[8]= Instrument9;
	PAIR[9]= Instrument10;


   IndicatorShortName("MTF_MCP_Fractal_Bar_Indicator");
   int windowIndex=WindowFind("MTF_MCP_Fractal_Bar_Indicator");

   if(windowIndex<0)
     {
      // if the subwindow number is -1, there is an error
      Print("Can\'t find window");
      return(0);
     }
 for(int x=0;x<ArraySize(TF);x++)
      for(int y=0;y<ArraySize(PAIR);y++)
        {
         ObjectCreate("signal"+windowIndex+x+y,OBJ_LABEL,windowIndex,0,0,0,0);
         ObjectSet("signal"+windowIndex+x+y,OBJPROP_XDISTANCE,x*scaleX+offsetX);
         ObjectSet("signal"+windowIndex+x+y,OBJPROP_YDISTANCE,y*scaleY+offsetY);
         ObjectSetText("signal"+windowIndex+x+y,CharToStr(110),fontSize,"Wingdings",Gold);
        }

   for(x=0;x<ArraySize(TF);x++)
     {
      ObjectCreate("textPeriod"+windowIndex+x,OBJ_LABEL,windowIndex,0,0,0,0);
      ObjectSet("textPeriod"+windowIndex+x,OBJPROP_XDISTANCE,x*scaleX+offsetX);
      ObjectSet("textPeriod"+windowIndex+x,OBJPROP_YDISTANCE,offsetY-10);
      ObjectSetText("textPeriod"+windowIndex+x,TF[x],8,"Tahoma",Blue);
     }

   for(y=0;y<ArraySize(PAIR);y++)
     {
      ObjectCreate("textSignal"+windowIndex+y,OBJ_LABEL,windowIndex,0,0,0,0);
      ObjectSet("textSignal"+windowIndex+y,OBJPROP_XDISTANCE,offsetX-50);
      ObjectSet("textSignal"+windowIndex+y,OBJPROP_YDISTANCE,y*scaleY+offsetY+8);
      ObjectSetText("textSignal"+windowIndex+y,PAIR[y],8,"Tahoma",Blue);
     }
//---- indicators
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  
  int windowIndex=WindowFind("MTF_MCP_Fractal_Bar_Indicator");
  
   for(int x=0;x<ArraySize(TF);x++)
   {
      for(int y=0;y<ArraySize(PAIR);y++)
	  {
         ObjectDelete("signal"+windowIndex+x+y);
	  }	 
	}	 

   for(x=0;x<ArraySize(TF);x++)
     {
      ObjectDelete("textPeriod"+windowIndex+x);     
     }
	 for(x=0;x<ArraySize(PAIR);x++)
	  {
	  ObjectDelete("textSignal"+windowIndex+y);
	  }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
int windowIndex=WindowFind("MTF_MCP_Fractal_Bar_Indicator"); 
int Q;
  
   for(int x=0;x<ArraySize(TF);x++)
   {
      for(int y=0;y<ArraySize(PAIR);y++)
        { 
		
		    Q= Calculate ( x,  y );
			
		  if (Q== 1)		  
          {
		  ObjectSetText("signal"+x+y,CharToStr(110),fontSize,"Wingdings",Blue);		  
		  }
		  else
		   {      if (Q== -1)		  
				  {
				  ObjectSetText("signal"+windowIndex+x+y,CharToStr(110),fontSize,"Wingdings",Red);		  
				  }
				  else
				  {
				  ObjectSetText("signal"+windowIndex+x+y,CharToStr(110),fontSize,"Wingdings",Silver);	
                  }				  
		  }
        }
	}
	

//----
   return(0);
}
  
  int Calculate (int x, int y )
  { 
    double Top=-1;
	double Bottom=-1;
	 
	    
			 int pos=0;
			 while(  pos < Lookback )
			 {   
 
				 
				  if (iHigh(PAIR[y],iTF[x],pos+2)>iHigh(PAIR[y],iTF[x],pos+4) && iHigh(PAIR[y],iTF[x],pos+2)>iHigh(PAIR[y],iTF[x],pos+3) && iHigh(PAIR[y],iTF[x],pos+2)>iHigh(PAIR[y],iTF[x],pos+1) && iHigh(PAIR[y],iTF[x],pos+2)>iHigh(PAIR[y],iTF[x],pos))
				  {
				   Top = iHigh(PAIR[y],iTF[x],pos+2) ;
				  }
				  
				  if ( iLow(PAIR[y],iTF[x],pos+2)< iLow(PAIR[y],iTF[x],pos+4) &&  iLow(PAIR[y],iTF[x],pos+2)< iLow(PAIR[y],iTF[x],pos+3) && iLow(PAIR[y],iTF[x],pos+2)< iLow(PAIR[y],iTF[x],pos+1) && iLow(PAIR[y],iTF[x],pos+2)< iLow(PAIR[y],iTF[x],pos))
				  {
				     Bottom = iLow(PAIR[y],iTF[x],pos+2) ;  
				  }
				  
				  
				  if (  (Top > 0 && Bottom > 0))
				  {
				  break;
			      }
				  
			   pos++;
			  }
			  
			  
			    
			  if (Top== -1 || Bottom== -1) 
			  {
			  return (0);
			  }
			  else
			  {
			  
			     if (iClose(PAIR[y],iTF[x],0)> Top)
                 {
				  return (1);
                 }	

                  if (iClose(PAIR[y],iTF[x],0)< Bottom)
                 {
				  return (-1);
                 }					 
			     else
				 {
				  return (0);
				 }
			
			 
    
             }
      return (0);
  }
  
  